****************************************************************
* DOSDIR - A simple MS-DOS style directory command
* Written by Todd Wallace AKA @LordDragon on the interwebz
* I can be found on the "Coco Discord" server and the Facebook
* group "TRS-80 Color Computer" or email todd@tektodd.com 
*
* Disclaimer: This does NOT support all the functions of the 
* real MS-DOS DIR commmand. You'll have to wait for me to port
* some free variant of DOS over to the 6809 Coco first. :P
*
* Thank you to everyone who has helped me learn the ropes
* of OS9 programming and assembly in general. In particular,
* Curtis L. Boyle and Deek for teaching me the ways of
* OS9 syscalls, William Astle and Dave Philipsen for tons
* of help in writing 32 bit math routines that even set CC
* correctly, and of course Simon Jonassen for getting me
* started with assembly in the first place.
*
* Feel free to use this code for whatever you want, just 
* please include my name in there somewhere. :D Thanks!
***************************************************************

STDOUT            EQU   1
STDIN 		EQU   2

	include 	OS9Defs
	pragma 	cescapes

; Module header setup info 
	MOD 	MODULE_SIZE,moduleName,$11,$80,START_EXEC,data_size

START_MODULE
**************************************************************************************
; -----------------------------------------------------
; Variables 
		org 	0

uRegImage 	RMB 	2
u16Value 	RMB 	2
u32Value 	RMB 	4
temp 		RMB 	14
fixedWidth 	RMB 	1
u32strLength 	RMB 	1
u16strLength 	RMB 	1

originalUID 	RMB 	2
;freeBytesFlag 	RMB 	1

dirsCounter 	RMB 	2
filesCounter 	RMB 	2
totalBytes 	RMB 	4
freeBytes 	RMB 	4
bufferCounter 	RMB 	1
;bytesPerCluster 	RMB 	4
;sectorsPerAllocByte RMB 	2
;bytesPerAllocation RMB 	4

drivePathName 	RMB 	6
volName 		RMB 	33 	; 32 chars for vol name + 1 for null terminator 
currentLSN 	RMB 	3
u8Value 		RMB 	1
sectorsPerCluster RMB 	2
allocationBytes 	RMB 	2

; lostwizard's variables for his free space calculator 
allocLastSector 	RMB 	1
allocSectCounter 	RMB 	1
totalBits	RMB 	3
bufferPtr 	RMB 	2

curDirPath 	RMB 	1
rawDrivePath 	RMB 	1
buffer 		RMB 	256
fdBuffer 	RMB 	256

windowPD 	RMB 	32
defaultPause 	RMB 	1

strFilename 	RMB 	30
strFileDate 	RMB 	18
strMiddleInfo 	RMB 	64
strFileSize 	RMB 	14    
strTemp 		RMB 	18
strU16ascii 	RMB 	6

; End of Variables
; -----------------------------------------------------
data_size         EQU   .
; -----------------------------------------------------
; Constants
moduleName 	FCS 	"dosdir"

curDirName 	FCC	".\r"
error  		FCC 	"Generic error.\r"

bin32dec1B 	FQB 	1000000000 	; 1 billion decimal 
bin32dec100M 	FQB 	100000000 	; 100 million decimal 
bin32dec10M 	FQB 	10000000 	; 10 million decimal 
bin32dec1M 	FQB 	1000000 		; 1 million decimal 
bin32dec100K 	FQB 	100000 		; 100 thousand decimal 
bin32dec10K 	FQB 	10000 	

; The table of bit counts. Order as 0x80...0xFF before the bitCountTable label 
; and 00...0x7F after it. These numbers may or may not be right.
; (they werent. edited by LordDragon :P)
                	FCB 7,6,6,5,6,5,5,4,6,5,5,4,5,4,4,3
                	FCB 6,5,5,4,5,4,4,3,5,4,4,3,4,3,3,2
                	FCB 6,5,5,4,5,4,4,3,5,4,4,3,4,3,3,2
                	FCB 5,4,4,3,4,3,3,2,4,3,3,2,3,2,2,1
                	FCB 6,5,5,4,5,4,4,3,5,4,4,3,4,3,3,2
                	FCB 5,4,4,3,4,3,3,2,4,3,3,2,3,2,2,1
                	FCB 5,4,4,3,4,3,3,2,4,3,3,2,3,2,2,1
         	FCB 4,3,3,2,3,2,2,1,3,2,2,1,2,1,1,0
bitCountTable   
		FCB 8,7,7,6,7,6,6,5,7,6,6,5,6,5,5,4
                	FCB 7,6,6,5,6,5,5,4,6,5,5,4,5,4,4,3
                	FCB 7,6,6,5,6,5,5,4,6,5,5,4,5,4,4,3
                	FCB 6,5,5,4,5,4,4,3,5,4,4,3,4,3,3,2
                	FCB 7,6,6,5,6,5,5,4,6,5,5,4,5,4,4,3
                	FCB 6,5,5,4,5,4,4,3,5,4,4,3,4,3,3,2
                	FCB 6,5,5,4,5,4,4,3,5,4,4,3,4,3,3,2
                	FCB 5,4,4,3,4,3,3,2,4,3,3,2,3,2,2,1

strAMPM 		FCC 	"AMPM"
strNewLine 	FCC 	"\r"
strVolName1 	FCN 	" Volume in drive "
strVolName2 	FCN 	" is "
strVolSerial 	FCC 	" Volume Serial Number is 6809-6309\r"
strDirectory 	FCN 	" Directory of "
strFiles 	FCN 	" File(s)  "
strDirs 		FCN 	" Dir(s)  "
strBytes 	FCC 	" bytes\r"
strBytesFree 	FCC 	" bytes free\r"

strName 		FCC 	"dosdir v1.1 - An MS-DOS inspired directory command.\r"
strAuthor 	FCC 	"Written by Todd Wallace (LordDragon)\r"
strUsage1 	FCC 	"Syntax: dosdir [-p] [path/to/dir]\r"
strUsage2 	FCC 	"   -p   Pause after each screenful of information.\r"

strErrorParams 	FCN 	"Invalid parameter. Use the -? flag for usage info.\r\n"
strErrorNotDir 	FCC 	"Error. Are you sure that's a directory?\r"
strErrorOpen	FCC 	"Specified directory not found.\r"
; -----------------------------------------------------

START_EXEC
**************************************************************************************
* Program code area 
* RULE #1 - USE U TO REFERENCE ANY CHANGEABLE VARIABLES IN THE DATA AREA.
* RULE #2 - USE PCR TO REFERENCE CONSTANTS SINCE THEY RESIDE WITH EXECUTABLE CODE.
* RULE #3 - NEVER USE JSR FOR CALLING SUBROUTINES. ALWAYS USE BSR OR LBSR INSTEAD.
**************************************************************************************

	stu 	<uRegImage

	; init the path variables 
	lda 	#$FF 
	sta 	curDirPath,U 
	sta 	rawDrivePath,U 

	;clr 	freeBytesFlag,U 

	; save the current userID number 
	os9 	F$ID 
	sty 	originalUID,U 
	; switch to user ID 0 for raw disk access 
	ldy 	#0
	os9 	F$SUser 

	pshs 	X 
	lda 	#STDOUT
	clrb 
	leax 	windowPD,U
	os9 	I$GetStt
	ldb 	windowPD+$07,U 
	stb 	defaultPause,U 
	puls 	X

	lda 	,X 
	cmpa 	#$0D 
	beq 	USE_CURRENT_DIR
PARAMS_NEXT
	; check for parameters 
	lbsr 	SEARCH_PARAMETER_FLAG
	bcs 	PARAMS_NO_MORE
	lda 	,X+
	cmpa 	#'?'
	bne 	PARAMS_CHECK_PAUSE_FLAG
	lda 	,X 
	cmpa 	#$20
	lbeq 	SHOW_USAGE
	cmpa 	#$0D
	lbeq 	SHOW_USAGE
	lbra 	ERROR_INVALID_PARAM
PARAMS_CHECK_PAUSE_FLAG
	lbsr 	CONVERT_UPPERCASE
	cmpa 	#'P'
	lbne 	ERROR_INVALID_PARAM
	lda 	,X
	cmpa 	#$20
	beq 	PARAMS_DO_PAUSE
	cmpa 	#$0D
	lbne 	ERROR_INVALID_PARAM
PARAMS_DO_PAUSE
	; turn on PAUSE mode 
	pshs 	X
	lda 	#STDOUT
	ldb 	#1
	stb 	windowPD+$07,U 
	clrb 
	leax 	windowPD,U 
	os9 	I$SetStt 
	puls 	X
	bra 	PARAMS_NEXT

PARAMS_NO_MORE
	lda 	,X
	cmpa 	#$0D 
	bne 	USE_MANUAL_DIR
USE_CURRENT_DIR
	leax 	curDirName,PCR 
USE_MANUAL_DIR
	lda 	#%10000001
	os9 	I$Open 
	lbcs 	ERROR_OPEN
	sta 	curDirPath,U 

	ldb 	#$0E 	; SS.DevNM code 
	leax 	buffer,U 
	os9 	I$GetStt
	lbcs 	EXIT_BAD

	ldb 	#6
	leay 	drivePathName,U 
	lda 	#'/'
	sta 	,Y+
GET_PATHNAME_NEXT_CHAR
	lda 	,X+
	bmi 	GET_PATHNAME_END
	sta 	,Y+
	decb 
	bne 	GET_PATHNAME_NEXT_CHAR
GET_PATHNAME_END
	anda 	#%01111111
	ldb 	#'@'
	std 	,Y++
	lda 	#$0D
	sta 	,Y 

	lda 	#READ.
	leax 	drivePathName,U 
	os9 	I$Open 
	lbcs 	EXIT_BAD
	sta 	rawDrivePath,U
	clr 	-1,Y 	; turn raw path name with @ into null terminated string

	leax 	buffer,U 
	ldy 	#$3F
	os9 	I$Read 

	ldd 	#0
	std 	dirsCounter,U 
	std 	filesCounter,U 
	std 	totalBytes,U 
	std 	totalBytes+2,U 


	ldd 	buffer+$04,U 
	std 	allocationBytes,U 
	ldd 	buffer+$06,U 
	std 	sectorsPerCluster,U 

	leay 	volName,U 
	leax 	buffer+$1F,U
VOLNAME_NEXT_CHAR
	lda 	,X+
	bmi 	VOLNAME_END
	sta 	,Y+
	bra 	VOLNAME_NEXT_CHAR

VOLNAME_END
	anda 	#%01111111
	ldb 	#$0D 
	std 	,Y

	lbsr 	WRITELN_NEWLINE_OS9
	leax 	strVolName1,PCR 
	lbsr 	PRINT_STR_OS9
	leax 	drivePathName,U 
	lbsr 	PRINT_STR_OS9
	leax 	strVolName2,PCR
	lbsr 	PRINT_STR_OS9
	leax 	volName,U 
	lbsr 	WRITELN_STR_OS9

	leax 	strVolSerial,PCR 
	lbsr 	WRITELN_STR_OS9
	lbsr 	WRITELN_NEWLINE_OS9

DIR_READ_NEXT_ENTRY
	; read a directory entry 
	lda 	curDirPath,U 
	leax 	buffer,U 
	ldy 	#32		; one entry is 32 bytes 
	os9 	I$Read 
	lbcs 	DIR_READ_END
	;cmpy 	#32 
	;lblo 	DIR_READ_END

	leay 	strFilename,U 
	lbsr 	EXTRACT_DIR_ENTRY
	bcs 	DIR_READ_NEXT_ENTRY

	; get the FD info for that entry 
	leax 	fdBuffer,U 
	ldb 	#16 		; get 16 bytes 
	lda 	currentLSN,U 
	tfr 	D,Y 
	lda 	rawDrivePath,U 
	ldb 	#$20 		; $SS.FDInf ($20) - Directly reads a file descriptor from anywhere
	ldu 	currentLSN+1,U 
	os9 	I$GetStt
	ldu 	<uRegImage

	; format the date/time info 
	ldb 	#2 
	stb 	fixedWidth,U  		; limit result to two chars 
	clra 
	ldb 	fdBuffer+$04,U  		; month value 
	leay 	strFileDate,U 
	lbsr 	CONVERT_BINARY16_DECIMAL 
	ldb 	#'/'
	stb 	-1,Y 	; overwrite the NULL 
	ldb 	fdBuffer+$05,U 
	lbsr 	CONVERT_BINARY16_DECIMAL
	ldb 	#'/'
	stb 	-1,Y 
	clr 	fixedWidth,U 
	ldb 	fdBuffer+$03,U 
	addd 	#1900
	lbsr 	CONVERT_BINARY16_DECIMAL
	leay 	-1,Y 

	ldd 	#$2020 		
	std 	,Y++ 		; add two spaces between date and time 

	ldb 	#2 
	stb 	fixedWidth,U 
	ldb 	fdBuffer+$06,U 
	; convert to AM/PM 
	cmpb 	#12 
	bls 	DIR_READ_HOUR_SKIP_SUBTRACT
	subb 	#12
DIR_READ_HOUR_SKIP_SUBTRACT
	clra 
	lbsr 	CONVERT_BINARY16_DECIMAL
	ldb 	#':'
	stb 	-1,Y 
	ldb 	fdBuffer+$07,U 
	lbsr 	CONVERT_BINARY16_DECIMAL
	ldb 	#$20
	stb 	-1,Y 		; add space before AM/PM 
	leax 	strAMPM,PCR  	; default to AM 
	ldb 	fdBuffer+$06,U 
	cmpb 	#12 
	blo 	DIR_READ_SKIP_PM
	leax 	2,X 
DIR_READ_SKIP_PM
	ldd 	,X 
	std 	,Y++ 	; write AM or PM ascii 
	clr 	,Y 	; null-terminator

	; print what we have so far 
	leax 	strFileDate,U 
	lbsr 	PRINT_STR_OS9

	; directory or file? 
	ldb 	fdBuffer,U 
	bmi 	DIR_READ_DIRECTORY
	
	; increment file count 
	ldd 	filesCounter,U 
	addd 	#1
	std 	filesCounter,U 

	; add to the total bytes of files in the directory 
	leax 	totalBytes,U 
	leay  	fdBuffer+$09,U 
	lbsr 	ADD_32BIT

	; convert 32bit filesize value into ascii 
	leax 	fdBuffer+$09,U 
	leay 	strFileSize,U 
	lbsr 	CONVERT_BINARY32_DECIMAL

	; fill in needed spaces 
	leax 	strMiddleInfo,U 
	ldb  	#18
	subb 	u32strLength,U 
	lda 	#$20
DIR_READ_FILESIZE_NEXT_SPACE
	sta 	,X+
	decb 
	bne 	DIR_READ_FILESIZE_NEXT_SPACE

	; now copy the ascii filesize data in 
DIR_READ_FILESIZE_COPY
	lda 	,Y+
	beq 	DIR_READ_FILESIZE_COPY_END
	sta 	,X+
	bra 	DIR_READ_FILESIZE_COPY
DIR_READ_FILESIZE_COPY_END
	ldd 	#$2000 		; single space between filesize and filename and null 
	std 	,X
	bra 	DIR_READ_PRINT_ENTRY

DIR_READ_DIRECTORY
	; increment directory counter 
	ldd 	dirsCounter,U 
	addd 	#1
	std 	dirsCounter,U 

	leay 	strMiddleInfo,U 
	; print direcotry line 
	ldd 	#$2020
	std 	,Y++
	std 	,Y++
	ldd 	#"<D"
	std 	,Y++
	ldd 	#"IR"
	std 	,Y++
	lda 	#'>'
	sta 	,Y+ 
	ldd 	#$2020
	std 	,Y++
	ldd 	#$2020
	std 	,Y++
	ldd 	#$2020
	std 	,Y++
	ldd 	#$2020
	std 	,Y++
	ldd 	#$2020
	std 	,Y++
	clr 	,Y 

DIR_READ_PRINT_ENTRY
	leax 	strMiddleInfo,U 
	lbsr 	PRINT_STR_OS9

	leax 	strFilename,U 
	lbsr 	WRITELN_STR_OS9
	lbra 	DIR_READ_NEXT_ENTRY

DIR_READ_END
	lbsr 	WRITELN_NEWLINE_OS9

	; print file/dir totals free bytes etc 
	clr 	fixedWidth,U 

	leay 	strU16ascii,U 
	ldd 	filesCounter,U 
	lbsr 	CONVERT_BINARY16_DECIMAL

	leay 	strTemp,U 
	ldb 	#16
	subb 	u16strLength,U 
	lda 	#$20
PRINT_FILES_TOTAL_ADD_SPACE
	sta 	,Y+
	decb 
	bne 	PRINT_FILES_TOTAL_ADD_SPACE
	clr 	,Y 

	; print the right-justified file total 
	leax 	strTemp,U 
	lbsr 	PRINT_STR_OS9
	leax 	strU16ascii,U 
	lbsr 	PRINT_STR_OS9

	leax 	strFiles,PCR 
	lbsr 	PRINT_STR_OS9

	leay 	strTemp,U 
	leax 	totalBytes,U 
	lbsr 	CONVERT_BINARY32_DECIMAL
	leax 	strTemp,U 
	lbsr 	PRINT_STR_OS9

	leax 	strBytes,PCR 
	lbsr 	WRITELN_STR_OS9

	; print out the total count of directories
	leay 	strU16ascii,U 
	ldd 	dirsCounter,U 
	lbsr 	CONVERT_BINARY16_DECIMAL

	leay 	strTemp,U 
	ldb 	#16 
	subb 	u16strLength,U
	lda 	#$20
PRINT_DIRS_TOTAL_ADD_SPACE
	sta 	,Y+
	decb 
	bne 	PRINT_DIRS_TOTAL_ADD_SPACE
	clr 	,Y 

	leax 	strTemp,U 
	lbsr 	PRINT_STR_OS9
	leax 	strU16ascii,U 
	lbsr 	PRINT_STR_OS9

	leax 	strDirs,PCR 
	lbsr 	PRINT_STR_OS9

	lbsr 	LOSTWIZARD_FREE_BYTES 	; using the FAT, calculate how many free bytes 
	leay 	strTemp,U 
	leax 	freeBytes,U 
	lbsr 	CONVERT_BINARY32_DECIMAL
	leax 	strTemp,U 
	lbsr 	PRINT_STR_OS9

	leax 	strBytesFree,PCR 
	lbsr 	WRITELN_STR_OS9
	bra 	EXIT 

SHOW_USAGE
	leax 	strName,PCR 
	lbsr 	WRITELN_STR_OS9
	leax 	strAuthor,PCR
	lbsr 	WRITELN_STR_OS9
	lbsr 	WRITELN_NEWLINE_OS9
	leax 	strUsage1,PCR 
	lbsr 	WRITELN_STR_OS9
	lbsr 	WRITELN_NEWLINE_OS9
	leax 	strUsage2,PCR
	lbsr 	WRITELN_STR_OS9
	bra 	EXIT_SKIP_RAW_PATH

ERROR_INVALID_PARAM
	leax 	strErrorParams,PCR 
	lbsr 	PRINT_STR_OS9
	bra 	EXIT_SKIP_RAW_PATH

ERROR_OPEN
	cmpb 	#$D6 
	bne 	ERROR_OPEN_NORMAL
	leax 	strErrorNotDir,PCR 
	bra 	ERROR_OPEN_PRINT
ERROR_OPEN_NORMAL
	leax 	strErrorOpen,PCR 
ERROR_OPEN_PRINT
	lda 	#STDOUT
	ldy 	#256
	os9 	I$WritLn 
	bra 	EXIT 

EXIT_BAD
	lda 	#STDOUT
	ldy 	#256
	leax 	error,PCR
	os9 	I$WritLn

EXIT
	lda 	curDirPath,U 
	bmi 	EXIT_SKIP_CUR_PATH
	os9 	I$Close 
EXIT_SKIP_CUR_PATH
	lda 	rawDrivePath,U 
	bmi 	EXIT_SKIP_RAW_PATH
	os9 	I$Close 
EXIT_SKIP_RAW_PATH
	; restore PD pause byte to original value 
	ldb 	defaultPause,U 
	stb 	windowPD+$07,U 
	lda 	#STDOUT
	leax 	windowPD,U 
	clrb 
	os9 	I$SetStt 
	nop 
	nop 
EXIT_FAST
	; restore original user's ID 
	ldy 	originalUID,U 
	os9 	F$SUser 
	nop 
	nop 
	nop 

	clrb 
	os9 	F$Exit 


************************************************************
* functions section
************************************************************
; --------------------------------
; do a CR+LF for a new line 
; --------------------------------
PRINT_NEWLINE_OS9
      pshs  Y,X,D 
      lda   #STDOUT
      ldy   #2
      leax  strNewLine,PCR 
      os9   I$Write
      puls  D,X,Y,PC 

; ------------------------------------------------------
; Print a NULL terminated string of characters to STDOUT
; (Max 256 characters not including NULL)
; Entry: X = pointer to NULL terminated string 
; ------------------------------------------------------
PRINT_STR_OS9
      pshs  Y,X,D 

      ; first find length 
      clrb
PRINT_STR_OS9_NEXT
      lda   ,X+
      beq   PRINT_STR_OS9_FOUND_LENGTH
      incb 
      bne   PRINT_STR_OS9_NEXT
      ; string is over 256 chars so print just those and return 
      ldy   #256
      bra   PRINT_STR_OS9_SKIP_LENGTH

PRINT_STR_OS9_FOUND_LENGTH
      clra 
      tfr   D,Y         ; move character count to Y for I$Write syscall 
PRINT_STR_OS9_SKIP_LENGTH
      lda   #STDOUT
      ldx   2,S         ; grab original value from stack 
      os9   I$Write
      nop 
      nop 

      puls  D,X,Y,PC 

; ----------------------------------------------------------------
; prints a string using I$WritLn and ends when it finds a CR ($0D)
; Entry: X = pointer to CR-terinated string 
; ----------------------------------------------------------------
WRITELN_STR_OS9
	pshs 	Y,D 
	lda 	#STDOUT 
	ldy 	#256
	os9 	I$WritLn 
	puls 	D,Y,PC 

; --------------------------------
; do a new line 
; --------------------------------
WRITELN_NEWLINE_OS9
      pshs  Y,X,D 
      lda   #STDOUT
      ldy   #1
      leax  strNewLine,PCR 
      os9   I$WritLn
      puls  D,X,Y,PC 

;---------------------------------
; convert to uppercase 
; Entry: A = character to be converted 
; Exit: A = converted character 
; --------------------------------
CONVERT_UPPERCASE
      ; check and/or convert lowercase to uppercase
      cmpa  #$61        ; $61 is "a"
      blo   CONVERT_UPPERCASE_NO_CONVERSION
      cmpa  #$7A  ; $7A is "z"
      bhi   CONVERT_UPPERCASE_NO_CONVERSION
      suba  #$20  ; convert from lowercase to uppercase 
CONVERT_UPPERCASE_NO_CONVERSION
      rts 

; -----------------------------------
; convert 16bit value to decimal ascii 
; Entry: Y = pointer to where to copy resulting ascii string 
; 	D = value to be converted 
; 	fixedWidth = 0 to remove ALL leading zeros in the output.
; 	fixedWidth non-zero means truncate result to that many chars 
; 	while inserting leading zeroes 
; Exit: Y = pointer to AFTER the null-terminator of output 
; -----------------------------------
CONVERT_BINARY16_DECIMAL
	pshs 	X,D 

	leax 	temp,U 
	ldd 	#$3030 	; ascii 0
	std 	,X
	std 	2,X 

	ldd 	,S 
CONVERT_BINARY16_DECIMAL_NEXT_10000
	subd 	#10000
	bcs 	CONVERT_BINARY16_DECIMAL_DO_1000
	inc 	,X 
	bra 	CONVERT_BINARY16_DECIMAL_NEXT_10000
CONVERT_BINARY16_DECIMAL_DO_1000
	addd 	#10000
CONVERT_BINARY16_DECIMAL_NEXT_1000
	subd 	#1000
	bcs 	CONVERT_BINARY16_DECIMAL_DO_100
	inc 	1,X 
	bra 	CONVERT_BINARY16_DECIMAL_NEXT_1000
CONVERT_BINARY16_DECIMAL_DO_100
	addd 	#1000
CONVERT_BINARY16_DECIMAL_NEXT_100
	subd 	#100
	bcs 	CONVERT_BINARY16_DECIMAL_DO_10
	inc 	2,X 
	bra 	CONVERT_BINARY16_DECIMAL_NEXT_100
CONVERT_BINARY16_DECIMAL_DO_10
	addd 	#100
CONVERT_BINARY16_DECIMAL_NEXT_10
	subd 	#10
	bcs 	CONVERT_BINARY16_DECIMAL_DO_1
	inc 	3,X 
	bra 	CONVERT_BINARY16_DECIMAL_NEXT_10
CONVERT_BINARY16_DECIMAL_DO_1
	addd 	#10
	addb 	#$30
	stb 	4,X 
	clr 	5,X 

	ldb 	fixedWidth,U 
	beq 	CONVERT_BINARY16_DECIMAL_SKIP_LEADING_ZEROES
	negb 
	addb 	#5
	leax 	B,X 
	bra 	CONVERT_BINARY16_DECIMAL_COPY

CONVERT_BINARY16_DECIMAL_SKIP_LEADING_ZEROES
	tst 	,X 
	beq 	CONVERT_BINARY16_DECIMAL_SKIP_LEADING_ZEROES_SINGLE
	ldb 	,X+
	cmpb 	#$30
	beq 	CONVERT_BINARY16_DECIMAL_SKIP_LEADING_ZEROES
CONVERT_BINARY16_DECIMAL_SKIP_LEADING_ZEROES_SINGLE
	leax 	-1,X 
	clrb 
CONVERT_BINARY16_DECIMAL_COPY
	incb
	lda 	,X+
	sta 	,Y+
	bne 	CONVERT_BINARY16_DECIMAL_COPY
	decb 
	stb 	u16strLength,U 

	puls 	D,X,PC 

; -------------------------------------
; convert 32 bit value to comma delimited decimal number 
; Entry: X = pointer to 32 bit value 
; 	Y = pointer to destination to write ASCII result 
; Exit:  B = length of resulting ascii string (not including null terminator)
; -------------------------------------
CONVERT_BINARY32_DECIMAL
	pshs 	Y,X,D 

	ldd 	,X 
	std 	u32Value,U 
	ldd 	2,X 
	std 	u32Value+2,U 

	ldd 	#"0,"
	std 	<temp 
	ldd 	#"00"
	std 	<temp+2
	ldd 	#"0,"
	std 	<temp+4
	ldd 	#"00"
	std 	<temp+6
	ldd 	#"0,"
	std 	<temp+8
	ldd 	#"00"
	std 	<temp+10
	ldd 	#$3000
	std 	<temp+12

	leax 	u32Value,U 
	leay 	bin32dec1B,PCR 
CONVERT_BINARY32_DECIMAL_NEXT_1B
	lbsr 	SUBTRACT_32BIT
	bcs 	CONVERT_BINARY32_DECIMAL_DO_100M
	inc 	<temp
	bra 	CONVERT_BINARY32_DECIMAL_NEXT_1B
CONVERT_BINARY32_DECIMAL_DO_100M
	lbsr 	ADD_32BIT
	leay 	bin32dec100M,PCR 
CONVERT_BINARY32_DECIMAL_NEXT_100M
	lbsr 	SUBTRACT_32BIT
	bcs 	CONVERT_BINARY32_DECIMAL_DO_10M
	inc 	<temp+2
	bra 	CONVERT_BINARY32_DECIMAL_NEXT_100M
CONVERT_BINARY32_DECIMAL_DO_10M
	lbsr 	ADD_32BIT
	leay 	bin32dec10M,PCR 
CONVERT_BINARY32_DECIMAL_NEXT_10M
	lbsr 	SUBTRACT_32BIT
	bcs 	CONVERT_BINARY32_DECIMAL_DO_1M
	inc 	<temp+3
	bra 	CONVERT_BINARY32_DECIMAL_NEXT_10M
CONVERT_BINARY32_DECIMAL_DO_1M
	lbsr 	ADD_32BIT
	leay 	bin32dec1M,PCR 
CONVERT_BINARY32_DECIMAL_NEXT_1M
	lbsr 	SUBTRACT_32BIT
	bcs 	CONVERT_BINARY32_DECIMAL_DO_100K
	inc 	<temp+4
	bra 	CONVERT_BINARY32_DECIMAL_NEXT_1M
CONVERT_BINARY32_DECIMAL_DO_100K
	lbsr 	ADD_32BIT
	leay 	bin32dec100K,PCR 
CONVERT_BINARY32_DECIMAL_NEXT_100K
	lbsr 	SUBTRACT_32BIT
	bcs 	CONVERT_BINARY32_DECIMAL_DO_10K
	inc 	<temp+6
	bra 	CONVERT_BINARY32_DECIMAL_NEXT_100K
CONVERT_BINARY32_DECIMAL_DO_10K
	lbsr 	ADD_32BIT
	leay 	bin32dec10K,PCR 
CONVERT_BINARY32_DECIMAL_NEXT_10K
	lbsr 	SUBTRACT_32BIT
	bcs 	CONVERT_BINARY32_DECIMAL_DO_1K
	inc 	<temp+7
	bra 	CONVERT_BINARY32_DECIMAL_NEXT_10K
CONVERT_BINARY32_DECIMAL_DO_1K
	lbsr 	ADD_32BIT
	ldd 	u32Value+2,U 
CONVERT_BINARY32_DECIMAL_NEXT_1K
	subd 	#1000
	bcs 	CONVERT_BINARY32_DECIMAL_DO_100
	inc 	<temp+8
	bra 	CONVERT_BINARY32_DECIMAL_NEXT_1K
CONVERT_BINARY32_DECIMAL_DO_100
	addd 	#1000
CONVERT_BINARY32_DECIMAL_NEXT_100
	subd 	#100
	bcs 	CONVERT_BINARY32_DECIMAL_DO_10
	inc 	<temp+10
	bra 	CONVERT_BINARY32_DECIMAL_NEXT_100
CONVERT_BINARY32_DECIMAL_DO_10
	addd 	#100
CONVERT_BINARY32_DECIMAL_NEXT_10
	subd 	#10
	bcs 	CONVERT_BINARY32_DECIMAL_DO_1
	inc 	<temp+11
	bra 	CONVERT_BINARY32_DECIMAL_NEXT_10
CONVERT_BINARY32_DECIMAL_DO_1
	addd 	#10
	addb 	#$30
	stb 	<temp+12

	; move pointer to eliminate leading zeroes 
	ldy 	4,S 		; get Y back from the stack 
	leax 	temp,U 
CONVERT_BINARY32_DECIMAL_SKIP_COMMA
	lda 	,X+
	beq 	CONVERT_BINARY32_DECIMAL_ZERO_RESULT
	cmpa 	#','
	beq 	CONVERT_BINARY32_DECIMAL_SKIP_COMMA
	cmpa 	#$30
	bne 	CONVERT_BINARY32_DECIMAL_FOUND
	bra 	CONVERT_BINARY32_DECIMAL_SKIP_COMMA
CONVERT_BINARY32_DECIMAL_ZERO_RESULT
	leax 	-1,X 
CONVERT_BINARY32_DECIMAL_FOUND
	leax 	-1,X
	clrb 
CONVERT_BINARY32_DECIMAL_COPY
	incb 
	lda 	,X+
	sta 	,Y+
	bne 	CONVERT_BINARY32_DECIMAL_COPY
	decb 
	stb 	u32strLength,U 

	puls 	D,X,Y,PC 

; -----------------------------------
; 32 bit subtraction 
; -----------------------------------
SUBTRACT_32BIT
      pshs  D
      ldd   2,X 
      subd  2,Y 
      std   2,X 
      ldd   ,X 
      sbcb  1,Y 
      sbca  ,Y 
      std   ,X 

      ; carry should be set properly now from subtract, now make sure zero flag works too
      ;ldd   ,X   ; not needed cuz previous instruction was STD ,X which already sets the Z and N flags 
      bne   SUBTRACT_32BIT_NOT_ZERO
      ldd   2,X
      andcc #%11110111 
SUBTRACT_32BIT_NOT_ZERO
      puls  D,PC 

 ;----------------------------------
 ; 32 bit addition 
 ; ---------------------------------
ADD_32BIT
      pshs  D 
      ldd   2,X 
      addd  2,Y 
      std   2,X 
      ldd   ,X 
      adcb  1,Y 
      adca  ,Y 
      std   ,X 

      bne   ADD_32BIT_NOT_ZERO
      ldd   2,X 
      andcc #%11110111
ADD_32BIT_NOT_ZERO
      puls  D,PC 

; ---------------------------------------
; scan for another flag parameter 
; Entry: X = pointing to string to search 
; Exit: on success, carry clear, X is pointing to the flag character returned 
;       on fail, carry set, X is pointer to first non-space char 
; ---------------------------------------
SEARCH_PARAMETER_FLAG
      pshs  A

      lbsr  SEARCH_NEXT_NONSPACE
      lda   ,X+
      cmpa  #'-'
      bne   SEARCH_PARAMETER_FLAG_NONE
      andcc #$FE        ; carry clear success
      puls  A,PC              

SEARCH_PARAMETER_FLAG_NONE
      leax  -1,X        ; undo auto-increment 
      orcc  #1          ; not found 
      puls  A,PC 
       
; -------------------------------------------------------
; scan for the next non-space character 
; Entry: X = pointing to area of string to search through 
; Exit: on success, carry clear, X points to the first non-space character 
;       on fail, carry set, X is restored to original value 
; -------------------------------------------------------
SEARCH_NEXT_NONSPACE
      pshs  X,D 

      clrb 
SEARCH_NEXT_NONSPACE_NEXT
      lda   ,X+
      cmpa  #$20
      bne   SEARCH_NEXT_NONSPACE_DONE
      decb 
      bne   SEARCH_NEXT_NONSPACE_NEXT
      ; never found a non-space character within 256 bytes 
      orcc  #1
      puls  D,X,PC            ; restore everything and return 

SEARCH_NEXT_NONSPACE_DONE      
      leax  -1,X              ; reverse the auto-increment
      puls  D 
      leas  2,S               ; skip X on the stack 
      andcc #$FE              ; carry clear on success 
      rts                     ; return with X pointing to non-space character 

; -----------------------------------------------------
; extract and copy out directory entry
; Entry: X = pointer to start of directory entry 
; 	Y = pointer to where to copy entry name string
; 	NOTE: terminator is a CR and not a null (so WriteLn works)
; ----------------------------------------------------- 
EXTRACT_DIR_ENTRY
	pshs 	Y,X,D 

	ldb 	#29
EXTRACT_DIR_ENTRY_NEXT_CHAR
	lda 	,X+ 
	beq 	EXTRACT_DIR_ENTRY_EMPTY
	bmi 	EXTRACT_DIR_ENTRY_NAME_END
	decb 
	beq 	EXTRACT_DIR_ENTRY_NAME_END	
	sta 	,Y+
	bra 	EXTRACT_DIR_ENTRY_NEXT_CHAR
EXTRACT_DIR_ENTRY_NAME_END
	anda 	#%01111111
	ldb 	#$0D 
	std 	,Y 
	; grab 3 byte LSN 
	ldx 	2,S 	; restore X from stack 
	lda 	29,X 
	sta 	currentLSN,U 
	ldd 	30,X 
	std 	currentLSN+1,U 
	; return success 
	andcc 	#$FE
	puls 	D,X,Y,PC 

EXTRACT_DIR_ENTRY_EMPTY
	orcc 	#1
	puls 	D,X,Y,PC 

; ------------------------------------------------------------------------------------
; caluclates the amount of free space on specific disk measured in bytes. this highly
; optimized routine was written by William Astle (@lostwizard on Discord). thanks
; alot for contributing to my project :D 
; ------------------------------------------------------------------------------------
LOSTWIZARD_FREE_BYTES_READ_SECT
       pshs   Y,X,D 
       lda    <rawDrivePath
       ldy    #256
       tfr    U,X  
       os9    I$Read 
       puls   D,X,Y,PC 

LOSTWIZARD_FREE_BYTES
       pshs   U,Y,X,D 

       ; seek to LSN 1 where allocation map begins 
       lda    <rawDrivePath 
       ldx    #0
       ldu    #256
       os9    I$Seek 
       ldu    <uRegImage

       leax   buffer,U
       stx    <bufferPtr 

       leay   bitCountTable,PCR                  ; point to bit counts lookup table
       clr    <totalBits                         ; clear count
       clr    <totalBits+1
       clr    <totalBits+2
       ldd    <allocationBytes                   ; get size of bitmap
       stb    <allocLastSector                   ; save bytes in last sector
       beq    LOSTWIZARD_FREE_BYTES_EVEN_SECTS   ; brif even number of sectors
       inca                                      ; account for fractional sector
LOSTWIZARD_FREE_BYTES_EVEN_SECTS
       sta    <allocSectCounter
       ldx    #0                                 ; blank out intermediate accumulator
LOSTWIZARD_FREE_BYTES_NEXTSECT 
       ldu    <bufferPtr                         ; point to buffer
       bsr    LOSTWIZARD_FREE_BYTES_READ_SECT    ; read a chunk
       ldb 	<allocSectCounter            
       bne    LOSTWIZARD_FREE_BYTES_NEXTCHUNK    ; is it last sector? brif not
       ldb 	<allocLastSector
       andb   #0x0F                              ; lose the upper bits
       subb   #16                                ; number of bytes not to process (negative)
       negb                                      ; now positive
       lslb                                      ; 4 bytes per process
       lslb
       clra                                      ; zero extend
       leau   LOSTWIZARD_FREE_BYTES_BYTEPROC,PCR ; point to byte processing "loop"
       leau   D,U                                ; adjust pointer to correct processor
       pshs   U                                  ; save address
       ldu    <bufferPtr                         ; get back buffer pointer
       ldb    <allocLastSector                   ; get bytes in last sector
       andb   #0xF0                              ; get the 16 bit boundary (already zero extended)
       leau   D,U                                ; adjust pointer
       clrb                                      ; reset sub accumulator
       rts                                       ; transfer control to correct handler
LOSTWIZARD_FREE_BYTES_NEXTCHUNK
       leau   240,U                              ; point to last 16 bytes of sector
LOSTWIZARD_FREE_BYTES_NEXTSUB
       clrb                                      ; initialize sub counter
LOSTWIZARD_FREE_BYTES_BYTEPROC
       lda    15,U                               ; process 16 bytes
       addb   A,Y
       lda    14,U
       addb   A,Y
       lda    13,U
       addb   A,Y
       lda    12,U
       addb   A,Y
       lda    11,U
       addb   A,Y
       lda    10,U
       addb   A,Y
       lda    9,U
       addb   A,Y
       lda    8,U
       addb   A,Y
       lda    7,U
       addb   A,Y
       lda    6,U
       addb   A,Y
       lda    5,U
       addb   A,Y
       lda    4,U
       addb   A,Y
       lda    3,U
       addb   A,Y
       lda    2,U
       addb   A,Y
       lda    1,U
       addb   A,Y
       lda    ,U
       addb   A,Y
       abx
       cmpu   <bufferPtr                         ; done whole sector?
       beq    LOSTWIZARD_FREE_BYTES_DONESECTOR   ; brif so
       leau   -16,U                              ; move back 16 bytes
       bra    LOSTWIZARD_FREE_BYTES_NEXTSUB
LOSTWIZARD_FREE_BYTES_DONESECTOR
	dec    <allocSectCounter                  ; account for the sector we're processing 
       beq    LOSTWIZARD_FREE_BYTES_DONEALL      ; have we done all sectors? brif so
       cmpx   #63487                             ; might X overflow on this next sector?
       bls    LOSTWIZARD_FREE_BYTES_NEXTSECT     ; brif not - do another sector
       tfr    X,D                                ; add sub total to grand total
       addd   <totalBits+1
       std    <totalBits+1
       ldb    <totalBits
       adcb   #0
       stb    <totalBits
       ldx    #0                                 ; reset sub total
       lbra   LOSTWIZARD_FREE_BYTES_NEXTSECT     ; go handle another sector
LOSTWIZARD_FREE_BYTES_DONEALL
       tfr    X,D                                ; accumulate final subtotal
       addd   <totalBits+1
       std    <totalBits+1
       ldb    <totalBits
       adcb   #0
       stb    <totalBits
                
       ; this part multiplies our 24 bit total of allocation bits by our 
       ; 16 bit sectors per cluster value 
       clr    <u16Value
       lda    <totalBits+2
       ldb    <sectorsPerCluster+1
       mul 
       stb    <temp+3         
       sta    <u16Value+1                        ; this is the carry byte 
       lda    <totalBits+1
       ldb    <sectorsPerCluster+1
       mul 
       addd   <u16Value 
       stb    <temp+2
       sta    <u16Value+1
       lda    <totalBits 
       ldb    <sectorsPerCluster+1
       mul 
       addd   <u16Value 
       std    <temp  

       clr    <u32Value+3
       lda    <totalBits+2
       ldb    <sectorsPerCluster
       mul 
       stb    <u32Value+2         
       sta    <u16Value+1                        ; this is the carry byte 
       lda    <totalBits+1
       ldb    <sectorsPerCluster
       mul 
       addd   <u16Value 
       stb    <u32Value+1
       sta    <u16Value+1
       lda    <totalBits 
       ldb    <sectorsPerCluster
       mul 
       addd   <u16Value 
       stb    <u32Value                          ; trunacate A  
       ; add the 2 parts together and store result shifted over by 1 byte to 
       ; effectively multiply by 256 bytes per sector 
       clr    <freeBytes+3
       ldd    <temp+2 
       addd   <u32Value+2 
       std    <freeBytes+1 
       ldd    <temp 
       adcb   <u32Value+1 
       stb    <freeBytes  

       puls   D,X,Y,U,PC

*************************************************************************************
	EMOD 
MODULE_SIZE 	; put this at the end so it can be used for module size 